<?php

namespace App\Http\Requests;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class ScreenRequest extends FormRequest
{

    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin', 'sub_admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule('screens'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules = [
            'first_image' => 'required',
            'second_image' => 'required',
            'third_image' => 'required',
        ];

        foreach (languages() as $lang) {
            $lang_rules=[
                'first_title_'.$lang->local=> 'required|min:3|max:100',
                'first_description_'.$lang->local=> 'required|min:3',
                'second_title_'.$lang->local=> 'required|min:3|max:100',
                'second_description_'.$lang->local=> 'required|min:3',
                'third_title_'.$lang->local=> 'required|min:3|max:100',
                'third_description_'.$lang->local=> 'required|min:3',
            ];
            $rules= array_merge($rules, $lang_rules);
        }
        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $field = metaFields('screens');
        $local = getCurrentLocale();
        $attributes=[
            'first_image' => $field[$local]['first_image'] ?? __('screens.first_image'),
            'second_image' => $field[$local]['second_image'] ?? __('screens.second_image'),
            'third_image' => $field[$local]['third_image'] ?? __('screens.third_image'),
        ];

        foreach (languages() as $lang) {
            $lang_attributes=[
                'first_title_'.$lang->local=> $field[$lang->local]['first_title'] ?? __('screens.first_title'),
                'first_description_'.$lang->local=> $field[$lang->local]['first_description'] ?? __('screens.first_description'),
                'second_title_'.$lang->local=> $field[$lang->local]['second_title'] ?? __('screens.second_title'),
                'second_description_'.$lang->local=> $field[$lang->local]['second_description'] ?? __('screens.second_description'),
                'third_title_'.$lang->local=> $field[$lang->local]['third_title'] ?? __('screens.third_title'),
                'third_description_'.$lang->local=> $field[$lang->local]['third_description'] ?? __('screens.third_description'),
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
    	// Change response attitude if the request done via Ajax requests like API requests

    	if(Request::ajax()){
	        $errors = $validator->errors()->first();
	        throw new HttpResponseException(response()->json(['errors' => $errors]));
	    } else {
	    	// Do the original action of the Form request class
	    	parent::failedValidation($validator);
	    }
    }
}
